=== requirements.txt ===
numpy
nose2
