=== debian/changelog ===
aubio (0.4.3-4) unstable; urgency=medium

  * debian/control: aubio-tools now depends on python3-aubio
  * debian/control: fix python3 Depends/Suggests for python3-aubio
  * debian/control: remove old Provides, XB-P-V, and Replaces/Conflicts
  * debian/python*-aubio.install: removed, use pybuild
  * debian/patches/pytest_local_import.diff: create python/tests/__init__.py
  * debian/patches/pytest_local_import.diff: use local imports for python3
  * debian/patches/sort_pysrc.diff: update to sort existing generated files
  * debian/patches/cleaner_clean.diff: prevent ./setup.py clean failures
  * debian/rules: remove old flags, not needed anymore for compat 9
  * debian/rules: use pybuild to install python packages
  * debian/rules: customize pybuild to use nose2 tests
  * debian/rules: simplify clean rule

 -- Paul Brossier <piem@debian.org>  Sun, 27 Nov 2016 22:23:50 +0100

aubio (0.4.3-3) unstable; urgency=medium

  * debian/patches/sort_pysrc.diff: also sort the list of generated files
  * debian/control: update Vcs-Git to use https
  * debian/patches/waf_cstlib_inst-8698499.diff: merge upstream, remove
    hardcoded copy in debian/rules
  * debian/rules: pass multi-arch libdir
  * debian/libaubio*.install: install from multi-arch libdir
  * debian/control: make libaubio5 multi-arch
  * debian/control: bump to debhelper >=9.0.0

 -- Paul Brossier <piem@debian.org>  Sat, 26 Nov 2016 16:34:33 +0100

aubio (0.4.3-2) unstable; urgency=medium

  * Now at last upstream version (closes: #828039)
  * debian/patch/skip_ppc64.diff: skip test if fft(zeros).phas != 0 [powerpc]
    (closes: #843482)
  * debian/patches/alpha_norm-88c89e3.diff: pull from upstream (avoid random
    test failures)
  * debian/patches/sort_pysrc.diff: sort(glob.glob) to improve build
    reproducibility
  * debian/patches/avcodec_update.diff: avoid libav deprecation warning
  * debian/control: update Vcs-Browser
  * debian/rules: improve test command

 -- Paul Brossier <piem@debian.org>  Mon, 07 Nov 2016 13:18:01 +0100

aubio (0.4.3-1) unstable; urgency=medium

  * Imported Upstream version 0.4.3
  * debian/patches/wscript_avcodec.patch: merged upstream
  * debian/patches/local_mathjax.patch: update
  * debian/patches/fixtests-5d8cc71.patch: use 5s brown noise
  * debian/rules: add -Wl,--as-needed
  * debian/rules: update python build, run python tests
  * debian/control: Standards-Version 3.9.8, debian/compat: 9
  * debian/control: bump to libaubio5
  * debian/control: update short description

 -- Paul Brossier <piem@debian.org>  Sun, 06 Nov 2016 01:38:30 +0100

aubio (0.4.2-1) unstable; urgency=medium

  * New upstream release.
  * Acknowledge NMU, thanks to toddy and sramacher (closes: #806604, #803799).
  * debian/patches/ffmpeg_2.9.patch: removed
  * debian/patches/wscript_avcodec.patch: fix avcodec detection
  * debian/patches/local_mathjax.patch: added .patch
  * debian/patches/series: update
  * debian/control: add | liback-jack2-dev, python-setuptools, dh-python
  * debian/control: bump to Standards-Version 3.9.6
  * debian/rules: cleaner clean, use python install --root= --prefix=
  * debian/rules: no more --nocache for waf, force static library install

 -- Paul Brossier <piem@debian.org>  Mon, 15 Aug 2016 13:40:35 +0200

aubio (0.4.1-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS when built with dpkg-buildpackage -A.
    Thanks to Santiago Vila <sanvila@unex.es> (Closes: #806604)

 -- Dr. Tobias Quathamer <toddy@debian.org>  Fri, 05 Aug 2016 17:34:40 +0200

aubio (0.4.1-2.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Andreas Cadhalpun ]
  * debian/patches/ffmpeg_2.9.patch: Fix build against ffmpeg 3.0. (Closes:
    #803799)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 06 Mar 2016 22:06:41 +0100
