=== debian/changelog ===
aubio (0.4.5-1build1) artful; urgency=medium

  * No-change rebuild to build to drop python3.5.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 05 Aug 2017 16:25:11 +0000

aubio (0.4.5-1) unstable; urgency=medium

  * New upstream version 0.4.5
  * Apply patch for 0.4.3-4.1 (thanks to Dr. Tobias Quathamer, closes: #862804)
  * debian/control: update homepage to https
  * debian/patches: delete all patches merged upstream
  * debian/rules: clean sphinx doc, this_version.pyc, and aubio.egg-info
  * debian/rules: add /usr/bin/aubio to aubio-tools
  * debian/watch: check upstream signature

 -- Paul Brossier <piem@debian.org>  Mon, 24 Jul 2017 15:11:01 +0200

aubio (0.4.3-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove python-related alternates from Build-Depends.
  * Fix d/rules to invoke tests with correct version of Python 3.
    Thanks to Michael Hudson-Doyle <michael.hudson@ubuntu.com> for
    the bug report and patch. Closes: #862804

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sun, 02 Jul 2017 17:35:53 +0200
