=== debian/control ===
--- 
+++ 
@@ -14,11 +14,11 @@
                libasound2-dev,
                libfftw3-dev,
                dh-python,
-               python | python-all | python-dev | python-all-dev,
+               python-all-dev,
                python-setuptools,
                libpython2.7-dev,
                python-numpy,
-               python3 | python3-all | python3-dev | python3-all-dev,
+               python3-all-dev,
                python3-setuptools,
                libpython3-dev,
                python3-numpy,
@@ -32,7 +32,7 @@
 Standards-Version: 3.9.8
 X-Python-Version: >= 2.6
 X-Python3-Version: >= 3.2
-Homepage: http://aubio.org
+Homepage: https://aubio.org
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/aubio.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/aubio.git/
