=== debian/rules ===
--- 
+++ 
@@ -13,12 +13,12 @@
 
 export PYBUILD_NAME=aubio
 export PYBUILD_AFTER_INSTALL_python2=rm -vrf '{destdir}/usr/bin'
-export PYBUILD_AFTER_INSTALL_python3=mv '{destdir}/usr/bin/aubiocut' '{dir}/debian/tmp/usr/bin'
+export PYBUILD_AFTER_INSTALL_python3=mv '{destdir}/usr/bin/aubio' '{destdir}/usr/bin/aubiocut' '{dir}/debian/tmp/usr/bin'
 
 export PYBUILD_BEFORE_TEST=make create_test_sounds; cp -prv '{dir}/python/tests' '{build_dir}'
 export PYBUILD_AFTER_TEST=rm -rf '{build_dir}/tests'; rm -rf '{dir}/python/tests/sounds'
 export PYBUILD_TEST_ARGS_python2=cd '{build_dir}'; nose2-2.7 --verbose
-export PYBUILD_TEST_ARGS_python3=cd '{build_dir}'; nose2-3 --verbose
+export PYBUILD_TEST_ARGS_python3=cd '{build_dir}'; python{version} `which nose2-3` --verbose
 
 %:
 	dh $@ --with python2,python3 --buildsystem=pybuild
@@ -27,7 +27,10 @@
 	dh_auto_clean --buildsystem=pybuild
 	-$(WAF_CMD) distclean
 	rm -rf doc/web/
+	rm -rf doc/_build/
 	rm -rf python/ext/config.h
+	rm -rf aubio.egg-info/
+	rm -f this_version.pyc
 	# extra rules to remove files manually
 	#-find waf -name '*.pyc' -delete
 	#rm -rf .waf* .lock-waf*
