=== debian/watch ===
version=2
opts="pgpsigurlmangle=s/$/.asc/" \
  http://aubio.org/pub/ aubio-([0-9.]*)\.tar\.bz2
